#define maxSize 1000 //       

#include <cstdio>
#include <list>
using namespace std;

struct pixelInfo { //            
    int color;
    int ordering;
};

pixelInfo pixels[maxSize][maxSize]; //   

struct sectorInfo { //       ,    ,    
    pixelInfo info;
    int finish;
};

//               :
// startX, startY       
// row  true,   , false   
// sectorSize    
// totalSize       
void process(int startX, int startY, bool row, int sectorSize, int totalSize)
{
    list<sectorInfo> stairs; //  ,   
    int x = startX, y = startY; //   

    //      ( )   ( ):
    for (int i = 0; i < totalSize; i++)
    {
        //    ,     :
        while (!stairs.empty() && stairs.front().finish == i)
        {
            stairs.pop_front();
        }

        if (pixels[x][y].ordering != -1) //       
        {
            //      ,    :
            while (!stairs.empty() && stairs.back().info.ordering < pixels[x][y].ordering)
            {
                stairs.pop_back();
            }

            //     :
            stairs.push_back((sectorInfo){.info = pixels[x][y], .finish = i + sectorSize});
        }

        //       :
        if (!stairs.empty())
        {
            pixels[x][y] = stairs.front().info;
        }

        //        :
        if (row)
        {
            x++;
        }
        else
        {
            y++;
        }
    }
}

int main()
{
    freopen("monitor.in", "r", stdin);
    freopen("monitor.out", "w", stdout);

    int m, n, w, h, k; //      ,    
    scanf("%d%d%d%d%d", &m, &n, &w, &h, &k);

    //    ,     :
    for (int x = 0; x < m; x++)
    {
        for (int y = 0; y < n; y++)
        {
            pixels[x][y] = (pixelInfo){.color = 0, .ordering = -1};
        }
    }

    //          :
    for (int i = 0; i < k; i++)
    {
        int x, y, c;
        scanf("%d%d%d", &x, &y, &c);
        pixels[x][y] = (pixelInfo){.color = c, .ordering = i};
    }

    //     ,     
    //   ,       :
    for (int x = 0; x < m; x++)
    {
        process(x, 0, false, h, n);
    }

    //            :
    for (int y = 0; y < n; y++)
    {
        process(0, y, true, w, m);
    }

    //        :
    for (int y = 0; y < n; y++)
    {
        for (int x = 0; x < m; x++)
        {
            printf(x > 0 ? " %d" : "%d", pixels[x][y].color);
        }
        printf("\n");
    }
}
